import { LoggerService, DynamicModule, NestModule, MiddlewareConsumer } from "@nestjs/common";
import pino, { LoggerOptions, DestinationStream } from "pino";
declare type PassedLogger = {
    logger: pino.Logger;
};
declare type Params = [] | [PassedLogger] | [LoggerOptions | DestinationStream] | [LoggerOptions, DestinationStream];
export declare class Logger implements LoggerService {
    verbose(msg: string, ...args: any[]): void;
    verbose(obj: object, msg?: string, ...args: any[]): void;
    debug(msg: string, ...args: any[]): void;
    debug(obj: object, msg?: string, ...args: any[]): void;
    log(msg: string, ...args: any[]): void;
    log(obj: object, msg?: string, ...args: any[]): void;
    warn(msg: string, ...args: any[]): void;
    warn(obj: object, msg?: string, ...args: any[]): void;
    error(msg: string, ...args: any[]): void;
    error(obj: object, msg?: string, ...args: any[]): void;
}
export declare class LoggerModule implements NestModule {
    static forRoot(...params: Params): DynamicModule;
    configure(consumer: MiddlewareConsumer): void;
}
declare global {
    namespace Express {
        interface Request {
            log: pino.Logger;
        }
    }
}
export {};
