"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var LoggerModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const express_pino_logger_1 = __importDefault(require("express-pino-logger"));
const pino_1 = __importDefault(require("pino"));
const express_ctx_1 = require("express-ctx");
let outOfContextLogger;
const loggerKey = "logger";
let rootParams;
let Logger = class Logger {
    verbose(...params) {
        return (express_ctx_1.getValue(loggerKey) || outOfContextLogger).trace(...params);
    }
    debug(...params) {
        return (express_ctx_1.getValue(loggerKey) || outOfContextLogger).debug(...params);
    }
    log(...params) {
        return (express_ctx_1.getValue(loggerKey) || outOfContextLogger).info(...params);
    }
    warn(...params) {
        return (express_ctx_1.getValue(loggerKey) || outOfContextLogger).warn(...params);
    }
    error(...params) {
        return (express_ctx_1.getValue(loggerKey) || outOfContextLogger).error(...params);
    }
};
Logger = __decorate([
    common_1.Injectable()
], Logger);
exports.Logger = Logger;
let LoggerModule = LoggerModule_1 = class LoggerModule {
    static forRoot(...params) {
        rootParams = params;
        if (hasLoggerParamsPassedLogger(rootParams)) {
            outOfContextLogger = rootParams[0].logger;
        }
        else {
            outOfContextLogger = pino_1.default(...rootParams);
        }
        return {
            module: LoggerModule_1,
            providers: [Logger],
            exports: [Logger]
        };
    }
    configure(consumer) {
        consumer
            .apply(...createLoggerMiddlewares())
            .forRoutes({ path: "*", method: common_1.RequestMethod.ALL });
    }
};
LoggerModule = LoggerModule_1 = __decorate([
    common_1.Global(),
    common_1.Module({
        providers: [Logger],
        exports: [Logger]
    })
], LoggerModule);
exports.LoggerModule = LoggerModule;
function createLoggerMiddlewares() {
    return [
        express_ctx_1.middleware,
        express_pino_logger_1.default(...rootParams),
        (req, res, next) => {
            express_ctx_1.setValue(loggerKey, req.log);
            next();
        }
    ];
}
function hasLoggerParamsPassedLogger(params) {
    return params[0] && "logger" in params[0];
}
//# sourceMappingURL=index.js.map